require 'yamd'
require 'addressable/uri'

class FakkuPage < PageCrawler
  def image_url
    @parsed_html.at_css('img.current-page')['src']
  end
end

class FakkuChapter < ChapterCrawler
  def self.page_class
    FakkuPage
  end

  def pages_info
    # there's no need of an lazy enumerator here, no IO action is taken
    page_options = @parsed_html.at_css('div#content select.drop').css('option')
    pages_number = page_options.map { | option | option['value'].to_i }.max
    
    page_urls = (1..pages_number).to_a.map do | i |
      { url: self.url + "#page=#{i}" }
    end

    page_urls
  end

  def name
    @custom_data[:name]
  end
end

class FakkuCrawler < MangaCrawler
  def chapters_info
    url = URI.join(self.url, @parsed_html.at_css('a.button.green')['href'])
    [{ name: 'OnlyChapter',
      url: url }]
  end

  def self.chapter_class
    FakkuChapter
  end

  def name
    @parsed_html.at_css('div.content-name h1').text
  end
end

