require 'yamd'

class MangaherePage < PageCrawler
  def image_url
    @parsed_html.at_css('#viewer a img')['src']
  end
end

class MangahereChapter < ChapterCrawler
  def self.page_class
    MangaherePage
  end

  def pages_info
    # there's no need of an lazy enumerator here, no IO action is taken
    page_options = @parsed_html.at_css('.prew_page + select').css('option')
    page_urls = []
    page_options.each do | option |
      page_urls << { url: option['value'] }
    end
    page_urls
  end

  def name
    @custom_data[:name]
  end
end

class MangahereCrawler < MangaCrawler
  def self.chapter_class
    MangahereChapter
  end

  def chapters_info
    url = URI.join(self.url, @parsed_html.at_css('a.button.green')['href'])
    [{ name: 'OnlyChapter',
      url: url }]
  end

  def name
    @parsed_html.at_css('h1').text.strip
  end
end

