require 'yamd'

class MangaherePage < PageCrawler
  def image_url
    @parsed_html.at_css('#viewer a img:not(.loadingImg)')['src']
  end
end

class MangahereChapter < ChapterCrawler
  def self.page_class
    MangaherePage
  end

  def pages_info
    # there's no need of an lazy enumerator here, no IO action is taken
    page_options = @parsed_html.at_css('.prew_page + select').css('option')
    page_urls = []
    page_options.each do | option |
      page_urls << { url: option['value'] }
    end
    # drop the 'featured' page at end of each chapter
    if /featured/.match(page_urls.last[:url]) then
      page_urls[0...-1]
    else
      page_urls
    end
  end

  def name
    @custom_data[:name]
  end
end

class MangahereCrawler < MangaCrawler
  def self.chapter_class
    MangahereChapter
  end

  def chapters_info
    @parsed_html.css('.detail_list ul li a').reverse.map do | chapter_link |
      { name: chapter_link.text.strip,
        url: chapter_link['href']
      }
    end
  end

  def name
    @parsed_html.at_css('h1').text.strip
  end
end

